# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr, validator
from synctera_client_ng.models.outgoing_ach_request import OutgoingAchRequest

class AchInstruction(BaseModel):
    """
    AchInstruction
    """
    request: OutgoingAchRequest = Field(...)
    type: StrictStr = Field(...)
    __properties = ["request", "type"]

    @validator('type')
    def type_validate_enum(cls, v):
        if v not in ('ACH'):
            raise ValueError("must be one of enum values ('ACH')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AchInstruction:
        """Create an instance of AchInstruction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of request
        if self.request:
            _dict['request'] = self.request.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AchInstruction:
        """Create an instance of AchInstruction from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return AchInstruction.parse_obj(obj)

        _obj = AchInstruction.parse_obj({
            "request": OutgoingAchRequest.from_dict(obj.get("request")) if obj.get("request") is not None else None,
            "type": obj.get("type")
        })
        return _obj

