# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr, constr

class Address1(BaseModel):
    """
    Address1
    """
    address_line_1: constr(strict=True, max_length=100) = Field(..., description="Street address line 1")
    address_line_2: Optional[constr(strict=True, max_length=100)] = Field(None, description="Street address line 2")
    city: StrictStr = Field(..., description="City")
    country_code: StrictStr = Field(..., description="ISO-3166-1 Alpha-2 country code")
    postal_code: StrictStr = Field(..., description="Postal code")
    state: StrictStr = Field(..., description="State, region, province, or prefecture")
    __properties = ["address_line_1", "address_line_2", "city", "country_code", "postal_code", "state"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Address1:
        """Create an instance of Address1 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Address1:
        """Create an instance of Address1 from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return Address1.parse_obj(obj)

        _obj = Address1.parse_obj({
            "address_line_1": obj.get("address_line_1"),
            "address_line_2": obj.get("address_line_2"),
            "city": obj.get("city"),
            "country_code": obj.get("country_code"),
            "postal_code": obj.get("postal_code"),
            "state": obj.get("state")
        })
        return _obj

