# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, StrictBool, constr
from synctera_client_ng.models.billing_address import BillingAddress

class CardOptions(BaseModel):
    """
    CardOptions
    """
    billing_address: Optional[BillingAddress] = None
    card_present: Optional[StrictBool] = False
    cvv: Optional[constr(strict=True, max_length=3)] = None
    expiration: Optional[constr(strict=True, max_length=4, min_length=4)] = None
    __properties = ["billing_address", "card_present", "cvv", "expiration"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CardOptions:
        """Create an instance of CardOptions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of billing_address
        if self.billing_address:
            _dict['billing_address'] = self.billing_address.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CardOptions:
        """Create an instance of CardOptions from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return CardOptions.parse_obj(obj)

        _obj = CardOptions.parse_obj({
            "billing_address": BillingAddress.from_dict(obj.get("billing_address")) if obj.get("billing_address") is not None else None,
            "card_present": obj.get("card_present") if obj.get("card_present") is not None else False,
            "cvv": obj.get("cvv"),
            "expiration": obj.get("expiration")
        })
        return _obj

