# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist, constr
from synctera_client_ng.models.card_acceptor_model import CardAcceptorModel
from synctera_client_ng.models.network_fee_model import NetworkFeeModel

class ClearingModel(BaseModel):
    """
    ClearingModel
    """
    amount: StrictInt = Field(..., description="The amount of the transaction in the smallest whole denomination of the applicable currency (eg. For USD use cents)")
    card_acceptor: Optional[CardAcceptorModel] = None
    force_post: Optional[StrictBool] = False
    is_refund: Optional[StrictBool] = False
    mid: Optional[constr(strict=True, max_length=50, min_length=1)] = None
    network_fees: Optional[conlist(NetworkFeeModel)] = None
    original_transaction_id: StrictStr = Field(..., description="When you simulated a clearing the synchronous response would have included a `transaction.token`. That value should be used here.")
    __properties = ["amount", "card_acceptor", "force_post", "is_refund", "mid", "network_fees", "original_transaction_id"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ClearingModel:
        """Create an instance of ClearingModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of card_acceptor
        if self.card_acceptor:
            _dict['card_acceptor'] = self.card_acceptor.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in network_fees (list)
        _items = []
        if self.network_fees:
            for _item in self.network_fees:
                if _item:
                    _items.append(_item.to_dict())
            _dict['network_fees'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ClearingModel:
        """Create an instance of ClearingModel from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return ClearingModel.parse_obj(obj)

        _obj = ClearingModel.parse_obj({
            "amount": obj.get("amount"),
            "card_acceptor": CardAcceptorModel.from_dict(obj.get("card_acceptor")) if obj.get("card_acceptor") is not None else None,
            "force_post": obj.get("force_post") if obj.get("force_post") is not None else False,
            "is_refund": obj.get("is_refund") if obj.get("is_refund") is not None else False,
            "mid": obj.get("mid"),
            "network_fees": [NetworkFeeModel.from_dict(_item) for _item in obj.get("network_fees")] if obj.get("network_fees") is not None else None,
            "original_transaction_id": obj.get("original_transaction_id")
        })
        return _obj

