# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from synctera_client_ng.models.address2 import Address2

class CustomerServiceDetails(BaseModel):
    """
    The customer service details of the fintech partner, e.g. phone number, email address, etc.
    """
    address: Optional[Address2] = None
    email: Optional[StrictStr] = Field(None, description="The customer service email address")
    phone_number: Optional[StrictStr] = Field(None, description="The customer service phone number")
    __properties = ["address", "email", "phone_number"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CustomerServiceDetails:
        """Create an instance of CustomerServiceDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of address
        if self.address:
            _dict['address'] = self.address.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CustomerServiceDetails:
        """Create an instance of CustomerServiceDetails from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return CustomerServiceDetails.parse_obj(obj)

        _obj = CustomerServiceDetails.parse_obj({
            "address": Address2.from_dict(obj.get("address")) if obj.get("address") is not None else None,
            "email": obj.get("email"),
            "phone_number": obj.get("phone_number")
        })
        return _obj

