# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictStr, conint

class DepositPost(BaseModel):
    """
    DepositPost
    """
    account_id: StrictStr = Field(..., description="The ID of the account")
    back_image_id: StrictStr = Field(..., description="ID of the uploaded image of the back of the check")
    business_id: Optional[StrictStr] = Field(None, description="Unique ID for the business. Exactly one of `business_id` or `person_id` must be set. ")
    check_amount: conint(strict=True, ge=1) = Field(..., description="Amount on check in ISO 4217 minor currency units")
    deposit_currency: StrictStr = Field(..., description="ISO 4217 currency code for the deposit amount")
    front_image_id: StrictStr = Field(..., description="ID of the uploaded image of the front of the check")
    metadata: Optional[Dict[str, Any]] = Field(None, description="Optional field to store additional information about the resource. Intended to be used by the integrator to store non-sensitive data. ")
    person_id: Optional[StrictStr] = Field(None, description="Unique ID for the person. Exactly one of `person_id` or `business_id` must be set. ")
    __properties = ["account_id", "back_image_id", "business_id", "check_amount", "deposit_currency", "front_image_id", "metadata", "person_id"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DepositPost:
        """Create an instance of DepositPost from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DepositPost:
        """Create an instance of DepositPost from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return DepositPost.parse_obj(obj)

        _obj = DepositPost.parse_obj({
            "account_id": obj.get("account_id"),
            "back_image_id": obj.get("back_image_id"),
            "business_id": obj.get("business_id"),
            "check_amount": obj.get("check_amount"),
            "deposit_currency": obj.get("deposit_currency"),
            "front_image_id": obj.get("front_image_id"),
            "metadata": obj.get("metadata"),
            "person_id": obj.get("person_id")
        })
        return _obj

