# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from synctera_client_ng.models.provisioning_controls import ProvisioningControls

class DigitalWalletTokenization(BaseModel):
    """
    DigitalWalletTokenization
    """
    card_art_id: Optional[StrictStr] = Field(None, description="Specifies the digital wallet card art identifier for the card product.")
    provisioning_controls: Optional[ProvisioningControls] = None
    __properties = ["card_art_id", "provisioning_controls"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DigitalWalletTokenization:
        """Create an instance of DigitalWalletTokenization from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of provisioning_controls
        if self.provisioning_controls:
            _dict['provisioning_controls'] = self.provisioning_controls.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DigitalWalletTokenization:
        """Create an instance of DigitalWalletTokenization from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return DigitalWalletTokenization.parse_obj(obj)

        _obj = DigitalWalletTokenization.parse_obj({
            "card_art_id": obj.get("card_art_id"),
            "provisioning_controls": ProvisioningControls.from_dict(obj.get("provisioning_controls")) if obj.get("provisioning_controls") is not None else None
        })
        return _obj

