# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr

class Initialize3dsResponse(BaseModel):
    """
    Initialization for an External Card Transfer 3-D Secure Authentication response
    """
    device_data_collection_jwt: StrictStr = Field(..., description="JWT used for device data collection")
    device_data_collection_url: StrictStr = Field(..., description="URL used for device data collection")
    id: StrictStr = Field(..., description="The unique identifier of the 3DS authentication")
    __properties = ["device_data_collection_jwt", "device_data_collection_url", "id"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Initialize3dsResponse:
        """Create an instance of Initialize3dsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Initialize3dsResponse:
        """Create an instance of Initialize3dsResponse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return Initialize3dsResponse.parse_obj(obj)

        _obj = Initialize3dsResponse.parse_obj({
            "device_data_collection_jwt": obj.get("device_data_collection_jwt"),
            "device_data_collection_url": obj.get("device_data_collection_url"),
            "id": obj.get("id")
        })
        return _obj

