# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr, validator

class Lookup3dsRequestSdk(BaseModel):
    """
    Lookup3dsRequestSdk
    """
    authentication_indicator: StrictStr = Field(...)
    device_channel: StrictStr = Field(..., description="Channel through which Device Data Collection was performed  Channel | Description --- | --- `BROWSER` | Internet browser `SDK` | Mobile app ")
    id: StrictStr = Field(..., description="The unique identifier of the 3DS authentication")
    transaction_mode: StrictStr = Field(...)
    __properties = ["authentication_indicator", "device_channel", "id", "transaction_mode"]

    @validator('authentication_indicator')
    def authentication_indicator_validate_enum(cls, v):
        if v not in ('INSTALLMENT', 'PAYMENT', 'RECURRING'):
            raise ValueError("must be one of enum values ('INSTALLMENT', 'PAYMENT', 'RECURRING')")
        return v

    @validator('device_channel')
    def device_channel_validate_enum(cls, v):
        if v not in ('BROWSER', 'SDK'):
            raise ValueError("must be one of enum values ('BROWSER', 'SDK')")
        return v

    @validator('transaction_mode')
    def transaction_mode_validate_enum(cls, v):
        if v not in ('COMPUTER_DEVICE', 'MOBILE_DEVICE', 'TABLET_DEVICE'):
            raise ValueError("must be one of enum values ('COMPUTER_DEVICE', 'MOBILE_DEVICE', 'TABLET_DEVICE')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Lookup3dsRequestSdk:
        """Create an instance of Lookup3dsRequestSdk from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Lookup3dsRequestSdk:
        """Create an instance of Lookup3dsRequestSdk from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return Lookup3dsRequestSdk.parse_obj(obj)

        _obj = Lookup3dsRequestSdk.parse_obj({
            "authentication_indicator": obj.get("authentication_indicator"),
            "device_channel": obj.get("device_channel"),
            "id": obj.get("id"),
            "transaction_mode": obj.get("transaction_mode")
        })
        return _obj

