# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import json
import pprint
import re  # noqa: F401
from aenum import Enum, no_arg





class MinimumPaymentType(str, Enum):
    """
    * RATE_OR_AMOUNT: Describes a minimum payment scheme where the amount calculated is either a portion   of the balance due, or a fixed, minimum amount, whichever is greater. For example, if   set to 1.00% and $30, the minimum payment will be calculated as 1.00% of the balance, or   $30, whichever is greatest. However, the minimum payment will never exceed the statement   balance. * FULL: Describes a minimum payment scheme where the amount calculated is the entire account   balance at the end of the statement period.    Note that the choice of minimum payment type is constrained by the account type. 
    """

    """
    allowed enum values
    """
    FULL = 'FULL'
    RATE_OR_AMOUNT = 'RATE_OR_AMOUNT'

    @classmethod
    def from_json(cls, json_str: str) -> MinimumPaymentType:
        """Create an instance of MinimumPaymentType from a JSON string"""
        return MinimumPaymentType(json.loads(json_str))


