# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, validator

class NetworkFeeModel(BaseModel):
    """
    NetworkFeeModel
    """
    amount: StrictInt = Field(..., description="The amount of the fee in the smallest whole denomination of the applicable currency (eg. For USD use cents)")
    credit_debit: Optional[StrictStr] = Field(None, description="C = credit; D = debit")
    type: StrictStr = Field(...)
    __properties = ["amount", "credit_debit", "type"]

    @validator('credit_debit')
    def credit_debit_validate_enum(cls, v):
        if v is None:
            return v
        if v not in ('C', 'D'):
            raise ValueError("must be one of enum values ('C', 'D')")
        return v

    @validator('type')
    def type_validate_enum(cls, v):
        if v not in ('ACQUIRER_FEE', 'CROSS_BORDER_ISSUER_FEE', 'CUR_CONV_CARDHOLDER_FEE', 'CUR_CONV_ISSUER_FEE', 'INTERCHANGE_FEE', 'ISSUER_FEE', 'PINDEBIT_ASSOC_FEE', 'SWITCH_FEE'):
            raise ValueError("must be one of enum values ('ACQUIRER_FEE', 'CROSS_BORDER_ISSUER_FEE', 'CUR_CONV_CARDHOLDER_FEE', 'CUR_CONV_ISSUER_FEE', 'INTERCHANGE_FEE', 'ISSUER_FEE', 'PINDEBIT_ASSOC_FEE', 'SWITCH_FEE')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> NetworkFeeModel:
        """Create an instance of NetworkFeeModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> NetworkFeeModel:
        """Create an instance of NetworkFeeModel from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return NetworkFeeModel.parse_obj(obj)

        _obj = NetworkFeeModel.parse_obj({
            "amount": obj.get("amount"),
            "credit_debit": obj.get("credit_debit"),
            "type": obj.get("type")
        })
        return _obj

