# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, StrictStr, validator

class OutgoingAchPatch(BaseModel):
    """
    Update sent ach transaction
    """
    funds_availability_time: Optional[datetime] = None
    status: Optional[StrictStr] = None
    __properties = ["funds_availability_time", "status"]

    @validator('status')
    def status_validate_enum(cls, v):
        if v is None:
            return v
        if v not in ('CANCELED'):
            raise ValueError("must be one of enum values ('CANCELED')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OutgoingAchPatch:
        """Create an instance of OutgoingAchPatch from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if funds_availability_time (nullable) is None
        # and __fields_set__ contains the field
        if self.funds_availability_time is None and "funds_availability_time" in self.__fields_set__:
            _dict['funds_availability_time'] = None

        # set to None if status (nullable) is None
        # and __fields_set__ contains the field
        if self.status is None and "status" in self.__fields_set__:
            _dict['status'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OutgoingAchPatch:
        """Create an instance of OutgoingAchPatch from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return OutgoingAchPatch.parse_obj(obj)

        _obj = OutgoingAchPatch.parse_obj({
            "funds_availability_time": obj.get("funds_availability_time"),
            "status": obj.get("status")
        })
        return _obj

