# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr

class PatchAccountChargeSecuredAllOf(BaseModel):
    """
    PatchAccountChargeSecuredAllOf
    """
    is_ach_enabled: Optional[StrictBool] = Field(None, description="A flag to indicate whether ACH transactions are enabled.")
    is_card_enabled: Optional[StrictBool] = Field(None, description="A flag to indicate whether card transactions are enabled.")
    is_p2p_enabled: Optional[StrictBool] = Field(None, description="A flag to indicate whether P2P transactions are enabled.")
    is_system_auto_pay_enabled: Optional[StrictBool] = Field(None, description="A flag to indicate whether auto payments are enabled.")
    is_wire_enabled: Optional[StrictBool] = Field(None, description="A flag to indicate whether wire transactions are enabled.")
    note: Optional[StrictStr] = Field(None, description="Add an optional note when patching a charged secured account. A note is required when setting the status to or from SUSPENDED.")
    __properties = ["is_ach_enabled", "is_card_enabled", "is_p2p_enabled", "is_system_auto_pay_enabled", "is_wire_enabled", "note"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PatchAccountChargeSecuredAllOf:
        """Create an instance of PatchAccountChargeSecuredAllOf from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PatchAccountChargeSecuredAllOf:
        """Create an instance of PatchAccountChargeSecuredAllOf from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return PatchAccountChargeSecuredAllOf.parse_obj(obj)

        _obj = PatchAccountChargeSecuredAllOf.parse_obj({
            "is_ach_enabled": obj.get("is_ach_enabled"),
            "is_card_enabled": obj.get("is_card_enabled"),
            "is_p2p_enabled": obj.get("is_p2p_enabled"),
            "is_system_auto_pay_enabled": obj.get("is_system_auto_pay_enabled"),
            "is_wire_enabled": obj.get("is_wire_enabled"),
            "note": obj.get("note")
        })
        return _obj

