# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr, constr
from synctera_client_ng.models.patch_international_wire_details import PatchInternationalWireDetails

class PatchAccountsRequestRoutingIdentifiers(BaseModel):
    """
    PatchAccountsRequestRoutingIdentifiers
    """
    ach_routing_number: Optional[constr(strict=True, min_length=1)] = Field(None, description="The routing number used for US ACH payments. On write, Synctera will store the entire routing number; on read, we only return the last 4 characters. ")
    bank_name: Optional[constr(strict=True, min_length=1)] = Field(None, description="The name of the bank managing the account")
    international_wire_details: Optional[PatchInternationalWireDetails] = None
    wire_routing_number: Optional[StrictStr] = Field(None, description="The routing number used for domestic wire payments. On write, Synctera will store the entire routing number; on read, we only return the last 4 characters. ")
    __properties = ["ach_routing_number", "bank_name", "international_wire_details", "wire_routing_number"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PatchAccountsRequestRoutingIdentifiers:
        """Create an instance of PatchAccountsRequestRoutingIdentifiers from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of international_wire_details
        if self.international_wire_details:
            _dict['international_wire_details'] = self.international_wire_details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PatchAccountsRequestRoutingIdentifiers:
        """Create an instance of PatchAccountsRequestRoutingIdentifiers from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return PatchAccountsRequestRoutingIdentifiers.parse_obj(obj)

        _obj = PatchAccountsRequestRoutingIdentifiers.parse_obj({
            "ach_routing_number": obj.get("ach_routing_number"),
            "bank_name": obj.get("bank_name"),
            "international_wire_details": PatchInternationalWireDetails.from_dict(obj.get("international_wire_details")) if obj.get("international_wire_details") is not None else None,
            "wire_routing_number": obj.get("wire_routing_number")
        })
        return _obj

