# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr
from synctera_client_ng.models.personal_id_type import PersonalIdType

class PatchPersonalId(BaseModel):
    """
    PatchPersonalId
    """
    country_code: Optional[StrictStr] = Field(None, description="The updated ISO 3166 Alpha-2 country code for the country that issued the personal identifier. The country code cannot be modified for personal identifier types that have an implicit country, e.g. SSN. ")
    id_type: PersonalIdType = Field(...)
    identifier: Optional[StrictStr] = Field(None, description="The updated personal identifier")
    tenant: Optional[StrictStr] = Field(None, description="The id of the tenant containing the resource. This is relevant for Fintechs that have multiple workspaces. ")
    __properties = ["country_code", "id_type", "identifier", "tenant"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PatchPersonalId:
        """Create an instance of PatchPersonalId from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PatchPersonalId:
        """Create an instance of PatchPersonalId from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return PatchPersonalId.parse_obj(obj)

        _obj = PatchPersonalId.parse_obj({
            "country_code": obj.get("country_code"),
            "id_type": obj.get("id_type"),
            "identifier": obj.get("identifier"),
            "tenant": obj.get("tenant")
        })
        return _obj

