# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, constr

class ReplaceSecret200Response(BaseModel):
    """
    ReplaceSecret200Response
    """
    deleted_at: Optional[datetime] = Field(None, description="Timestamp that the old secret is delete")
    secret: Optional[constr(strict=True, max_length=64, min_length=64)] = Field(None, description="Generated secret. Do not share. This secret will be used to verify that webhook requests were sent from Synctera.")
    __properties = ["deleted_at", "secret"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ReplaceSecret200Response:
        """Create an instance of ReplaceSecret200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ReplaceSecret200Response:
        """Create an instance of ReplaceSecret200Response from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return ReplaceSecret200Response.parse_obj(obj)

        _obj = ReplaceSecret200Response.parse_obj({
            "deleted_at": obj.get("deleted_at"),
            "secret": obj.get("secret")
        })
        return _obj

