# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictStr, validator

class TransactionDispute(BaseModel):
    """
    TransactionDispute
    """
    created: datetime = Field(..., description="The creation time of the dispute")
    external_case_reference: Optional[StrictStr] = Field(None, description="The external case number or id for the dispute (eg: from a vendor such as Marqeta), if one exists.")
    id: StrictStr = Field(..., description="The unique identifier of the dispute.")
    internal_case_reference: Optional[StrictStr] = Field(None, description="The internal case number or id for the dispute in the Synctera platform, if one exists.")
    status: StrictStr = Field(...)
    updated: datetime = Field(..., description="The time the dispute was last updated")
    __properties = ["created", "external_case_reference", "id", "internal_case_reference", "status", "updated"]

    @validator('status')
    def status_validate_enum(cls, v):
        if v not in ('ARBITRATION', 'CASE_LOST', 'CASE_OPEN', 'CASE_WON', 'CHARGEBACK_INITIATED', 'NETWORK_REJECTED', 'PREARBITRATION', 'REPRESENTMENT'):
            raise ValueError("must be one of enum values ('ARBITRATION', 'CASE_LOST', 'CASE_OPEN', 'CASE_WON', 'CHARGEBACK_INITIATED', 'NETWORK_REJECTED', 'PREARBITRATION', 'REPRESENTMENT')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TransactionDispute:
        """Create an instance of TransactionDispute from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TransactionDispute:
        """Create an instance of TransactionDispute from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return TransactionDispute.parse_obj(obj)

        _obj = TransactionDispute.parse_obj({
            "created": obj.get("created"),
            "external_case_reference": obj.get("external_case_reference"),
            "id": obj.get("id"),
            "internal_case_reference": obj.get("internal_case_reference"),
            "status": obj.get("status"),
            "updated": obj.get("updated")
        })
        return _obj

