# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import json
import pprint
import re  # noqa: F401
from aenum import Enum, no_arg





class VerificationResult(str, Enum):
    """
    The determination of this verification. One of the following: * `UNVERIFIED` – record representing the absence of a verification. * `PENDING` – verification is in progress for this customer. * `PROVISIONAL` – partially verified or verified with restrictions. * `ACCEPTED` – the customer has been verified. * `REVIEW` – verification has run and issues have been identified and require review. * `VENDOR_ERROR` – verification did not successfully run due to an unexpected error or failure. * `REJECTED` – the customer was rejected and should not be allowed to take certain actions e.g., open an account. 
    """

    """
    allowed enum values
    """
    ACCEPTED = 'ACCEPTED'
    PENDING = 'PENDING'
    PROVISIONAL = 'PROVISIONAL'
    REJECTED = 'REJECTED'
    REVIEW = 'REVIEW'
    UNVERIFIED = 'UNVERIFIED'
    VENDOR_ERROR = 'VENDOR_ERROR'

    @classmethod
    def from_json(cls, json_str: str) -> VerificationResult:
        """Create an instance of VerificationResult from a JSON string"""
        return VerificationResult(json.loads(json_str))


