# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from synctera_client_ng.models.verification_vendor_json import VerificationVendorJson
from synctera_client_ng.models.verification_vendor_xml import VerificationVendorXml
from typing import Any, List
from pydantic import StrictStr, Field

VERIFICATIONVENDORINFO_ONE_OF_SCHEMAS = ["VerificationVendorJson", "VerificationVendorXml"]

class VerificationVendorInfo(BaseModel):
    """
    The information provided to Synctera from the vendor. Interpretation of this object is up to the client. 
    """
    # data type: VerificationVendorXml
    oneof_schema_1_validator: Optional[VerificationVendorXml] = None
    # data type: VerificationVendorJson
    oneof_schema_2_validator: Optional[VerificationVendorJson] = None
    actual_instance: Any
    one_of_schemas: List[str] = Field(VERIFICATIONVENDORINFO_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    discriminator_value_class_map = {
    }

    def __init__(self, *args, **kwargs):
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = VerificationVendorInfo.construct()
        error_messages = []
        match = 0
        # validate data type: VerificationVendorXml
        if not isinstance(v, VerificationVendorXml):
            error_messages.append(f"Error! Input type `{type(v)}` is not `VerificationVendorXml`")
        else:
            match += 1
        # validate data type: VerificationVendorJson
        if not isinstance(v, VerificationVendorJson):
            error_messages.append(f"Error! Input type `{type(v)}` is not `VerificationVendorJson`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in VerificationVendorInfo with oneOf schemas: VerificationVendorJson, VerificationVendorXml. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in VerificationVendorInfo with oneOf schemas: VerificationVendorJson, VerificationVendorXml. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> VerificationVendorInfo:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> VerificationVendorInfo:
        """Returns the object represented by the json string"""
        instance = VerificationVendorInfo.construct()
        error_messages = []
        match = 0

        # deserialize data into VerificationVendorXml
        try:
            instance.actual_instance = VerificationVendorXml.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into VerificationVendorJson
        try:
            instance.actual_instance = VerificationVendorJson.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into VerificationVendorInfo with oneOf schemas: VerificationVendorJson, VerificationVendorXml. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into VerificationVendorInfo with oneOf schemas: VerificationVendorJson, VerificationVendorXml. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        to_dict = getattr(self.actual_instance, "to_dict", None)
        if callable(to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())

