# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.63.0
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr, validator

class WatchlistSuppress(BaseModel):
    """
    WatchlistSuppress
    """
    provider_subject_id: StrictStr = Field(..., description="The id of the subject (person) for whom future alerts should be suppressed. ")
    provider_subscription_id: StrictStr = Field(..., description="The provider's id for the subscription that caused the alert(s) that are being suppressed. ")
    status: StrictStr = Field(..., description="The status of this suppression")
    __properties = ["provider_subject_id", "provider_subscription_id", "status"]

    @validator('status')
    def status_validate_enum(cls, v):
        if v not in ('SUPPRESS', 'UNSUPPRESS'):
            raise ValueError("must be one of enum values ('SUPPRESS', 'UNSUPPRESS')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> WatchlistSuppress:
        """Create an instance of WatchlistSuppress from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> WatchlistSuppress:
        """Create an instance of WatchlistSuppress from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return WatchlistSuppress.parse_obj(obj)

        _obj = WatchlistSuppress.parse_obj({
            "provider_subject_id": obj.get("provider_subject_id"),
            "provider_subscription_id": obj.get("provider_subscription_id"),
            "status": obj.get("status")
        })
        return _obj

